

/*
 Brett Oliver
 
 http://www.brettoliver.org.uk
//
//  Copyright 2018 Brett Oliver
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program. If not, see http://www.gnu.org/licenses/
// based on original project here https://create.arduino.cc/projecthub/user0035382/clock-with-alarm-hygrometer-thermometer-531acb
//
################  Added version number line 572 ###############
v7.0 put delays back in menu and add read temp humidity after exit clock set, removed EEPROM library
v7.1 on Sum Win adv/rtd the RTC hour is changed when the tmer records 3595 pulses to go.

v02 remove display
v05 removed display and DHT22
v06 add MAX2719 files etc changed minuteNow to secondNow
v07 adding time to display
v08 cut out old redundant code & nivel changed to level
v09 advrtdpin changed to inputpullup
v10 changed t0 rtclib 7seg disp working
v11 analogue display working
v12 added 30 sec sync
v13 add advance retard
v14 add adv rtd settings
v17 added adv retard.
v18 added summer winter setting 
v19 adding digital clock setting
v20 added max2719 intensity- changing pins for clock motor from A2/A3 to D9 & D 13
v21 added PIR
v22 added 12/24 hr
v23 add retard indicator on max digital display
v24 retard indicated by flashing digital display
*/





//###################################################################################################



#include <LedControl.h>
#include <Wire.h>
#include <SPI.h>
#include "RTClib.h"
//#include "EEPROM.h"

// Pin numbers for MAX72cc
// pin 12 is connected to the DataIn 
// pin 11 is connected to CLK
// pin 10 is connected to the LOAD  
// We have only a single MAX72XX.
 LedControl lc=LedControl(12,11,10,1);
 //  LedControl lc=LedControl(9,8,7,1);





int secondNow=0;
int secondPrevious=0;
int secondNow1=0;
int secondPrevious1=0;
int summertime = 0;
int wintertime = 0;

int Clock24Hour = 0; // 0 is 12 hour clock and 1 is 24hr clock

int extraLength = 500; //Length of extra pulse
int pulseLength = 400; // sets lenth of pulse by adjusting  delay max 400 min 50


int motorPulse = 0; //number of pulses sent to the motor to step 1 min (4)
int advancePulse = 0; //number of advance pulses remaining
int coilOn = 0;
unsigned long startMillis;
unsigned long currentMillis;
//unsigned long previousMillis = 0; 
const unsigned long periodOn = 100;//the value is a number of milliseconds clock motor is on
const unsigned long periodOff = 100;//the value is a number of milliseconds between clock motor steps

/*
#define DS3231_I2C_ADDRESS 104
byte tMSB, tLSB;
float temp3231;
byte hh, mm, ss;
byte yy, ll, dd, zz;
*/
RTC_DS3231 rtc;


//#define menu 2 
//#define minus 3
//#define plus 4
#define syncPulse 5  // 30 second sync pin

//#define backlight 10
int level = 0;   // if is 0 - clock
                 // if is 1 - hour adjust
                 // if is 2 - minute adjust

int hh1, mm1, zz1, dd1, mth1, yy1;   
int maxday;
boolean initial = 1;

int intensity = 0;// Digit display brightness value
int intensityPin = A2;// LDR analog pin
int max2719Intensity = 0; //Digit display intensity value sent to max2719



//Brett
int secondsNow = 0;
int secondsOld = 0;
int AdvRtdPin = A0; //Pin for sensing advance/retard setting
int AdvRtdVal = 0; // Analogue value 0-1023
int DigTimeSetPin = A1; //Pin for sensing digit for digital time setting
int DigTimeSet = 0; // Analogue value 0-1023
int DigitalClockDigit = 0; //Value of digit for digital clock setting

int hour1 = 2;
int hour2 = 3;
int minute1 = 4;
int minute2 = 8;


int AdvSet = 0; // Advance  pulses
int RtdSet = 0; //Retard pulses
int previousAdvRtdSet = 0; 
//int secsMiss = 0;    // used for calculating gained or missed seconds
//int secondssync = 0; //records seconds when sync pulse received
int adjCount = 0; // set to number of pulses from rotary switch value AdvRtdSet
int previousadjCount = 0;


int h = 0;
int m =0;
int s = 0;
int dd = 0;
int yy = 0;
int mth = 0;
int hours2 = 0; //2nd 7 segment hour digit
int hours1 = 0; //1st 7 segment hour digit
//int hours = 0;
int minutes2 = 0; //2nd 7 segment minute digit
int minutes1 = 0; //1st 7 segment minute digit
//int minutes = 0;
int seconds2 = 0;  //2nd 7 segment seconds digit
int seconds1 = 0; //1st 7 segment seconds digit

const byte PIRPin        = A3;// PIR sensor input pin
int PIROn                = 0;
long PIRtimer             = 0; //used for checking PIR timings
int PIRtimeout            = 600; //PIR time on after trigger in seconds

boolean coilStatus    = false;  // clock coil status
boolean retard        = false;  // true if clock going back
boolean advance       = true;  // false when AdvRtdSetUse is in use for counting advance/retard pulse values
boolean advanceLock   = false; // true hold on advance
boolean clockRun      = true;   // when false clock motor will stop used for retard and sync
boolean AdvRtdSetUse  = true;  // true if clock going back
boolean nosync        = true; // true allows 30 sec sync to go ahead only if clock is not advancing/retarding
boolean allowsync     = true; // true allows 30 sec re-sync after seconds get to 10 to stop multiple syncs when sync pulse received
boolean sumwin        = false; // true when setting sum win time


const int clockCoil01 = 9;  // was A2 clock coil
const int clockCoil02 = 13;  // was A3 clock coil 
const int retardSw = 6;                  
const int advanceSw = 7;                    



//Brett



void setup () 
{

Serial.begin(9600);
    Wire.begin();


pinMode(hour1, INPUT_PULLUP);
pinMode(hour2, INPUT_PULLUP);
pinMode(minute1, INPUT_PULLUP);
pinMode(minute2, INPUT_PULLUP);
pinMode(PIRPin, INPUT); 
pinMode(syncPulse, INPUT); 


pinMode(AdvRtdPin, INPUT);// adv rtd select
pinMode(DigTimeSetPin, INPUT);// digit select



pinMode(retardSw, INPUT_PULLUP);
pinMode(advanceSw, INPUT_PULLUP);

pinMode(clockCoil01, OUTPUT);
pinMode(clockCoil02, OUTPUT);
pinMode(intensityPin, INPUT); 

//digitalWrite(menu, HIGH);  // put inputs in high state (when push is to ground -> low state)
//digitalWrite(plus, HIGH);
//digitalWrite(minus, HIGH);


// The MAX72XX is in power-saving mode on startup,
// we have to do a wakeup call   
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,2);
  /* and clear the display */
  lc.clearDisplay(0);
  lc.setScanLimit(0, 7); // set to 8 digits
  

 
//rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));//set time from PC -don't use
// rtc.adjust(DateTime(2021, 12, 10, 7, 52, 0)); //manual adjustment




}


void loop () //#####################################################################
{
if (level == 0)
{
/*
if (digitalRead(menu) == LOW)
  {
  level = level+1;
  hh1=h;
  mm1=m;
 // zz1=zz;
  yy1=yy;
  mth1=mth;
  dd1=dd;
  
 
  }
*/

  


// 30 second sync to master clock pulse
if (digitalRead(syncPulse) == HIGH  && !advance && !retard && nosync == true && allowsync )// sync on 30seconds as long as clock not advancing or retarding
{ 
   
// Serial.println("syncpulse ");
 
  allowsync = false ;
  rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), rtc.now().hour(), rtc.now().minute(), 30));


}

if (rtc.now().second() == 10  )// allows seconds to sync again after seconds reach 10
     {
      allowsync = true ;
    //  Serial.println("10 Seconds ");
  
     }

// end 30 second sync to master clock pulse



// Steps clock 4 times every minute to advance the clock exactly 1 minute
 if ( !retard && !advance && clockRun == true && get_sec() == 0 ) // Normal pulse at 0 seconds
  {
   
 clockCoilTimer();

  }

// End Steps clock 4 times every minute to advance the clock exactly 1 minute




//
if ( get_sec() == 2 )
{
 motorPulse = 0; // at 2 seconds motor pulse is set to 0 ready to step again when seconds are 0 

 
}


// Brett Get Advance /Retard settings from pot
if (advance == false && retard == false) // only allows reading of pot when not advancing or retarding. Test fix for display staying on when pot is turned during advance/retard
{
// Serial.print ("Advance ");
 //    Serial.println (advance);
 AdvRtdSettings();
  
// Serial.println("AdvRtdSettings");
}
// End Get Advance /Retard settings from pot


// Man advance/retard

 if (digitalRead(retardSw) == LOW || digitalRead(advanceSw) == LOW && AdvRtdSetUse == true )
 {
  advancePulse = 0;
   AdvRtdSetUse = false;
 //  Serial.print ("RtdSet ");
 //  Serial.println (RtdSet);
 //  Serial.print ("advancePulse ");
  // Serial.println (advancePulse);
 }

 //Retarding
     if (digitalRead(retardSw) == LOW || (retard == 1 && RtdSet > 0)) //summer to winter clock goes back (misses AdvSet number of pulses)
 {   
    retard = true;
    secondNow1 = get_sec();
    if(secondNow1 !=secondPrevious1)// waits for a sec to elapse and take 1 off RtdSet ignores 0 secs
 {
      
      
    //   if (  adjCount != 5000)// adjcount 5000 stop
   //   {
   // Serial.print ("sumwin");
   //  Serial.println (sumwin);
     
 
      --RtdSet;
      secondPrevious1 = secondNow1;
    //  Serial.print ("advancePulse ");
   //  Serial.println (advancePulse);
   // Serial.print ("RtdSet ");
   //  Serial.println (RtdSet);

 }  
     //Adjust RTC back when hour after 1 hour wait
      if ( sumwin == true && RtdSet == 0)// summer winter selected retard RTC as well when count gets to 240 (1 hour)
      {
      wintertime = rtc.now().hour() - 1;
       
       rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), wintertime, rtc.now().minute(), rtc.now().second()));
          //sumwin = false;
          
      }
    
    }


    //Advancing
    else if (digitalRead(advanceSw) == LOW || (advance == true && AdvSet > 0)) //clock goes forward (AdvSet number of pulses)
    {   
      advance = true;
     // clockAdvance();
   //   if (  adjCount != 5000)// adjcount 5000 continous run
   //   {
     // Serial.print ("sumwin");
   //  Serial.println (sumwin);
// Clock advance

 
 // advanceLock = true;
  currentMillis = millis();  //get the current time
  if ((coilOn == 1) && (currentMillis - startMillis >= periodOn))  //test whether the period has elapsed
   { 
  coilOn = 0;
  digitalWrite(clockCoil01, coilStatus);
  digitalWrite(clockCoil02, !coilStatus);
  
  startMillis = currentMillis;
 // Serial.println ("coil is energised");  
   }
 else if ((coilOn == 0) && (currentMillis - startMillis >= periodOff))  //test whether the period has elapsed
  {
   coilOn = 1;
   coilStatus = !coilStatus;
    digitalWrite(clockCoil01, 0);
  digitalWrite(clockCoil02, 0);
    startMillis = currentMillis;  //IMPORTANT to save the start time of the current


  
   
   if(rtc.now().second()!= 0)// only takes 1 off AdvSet value when seconds are not at 0
   {
   -- AdvSet;// 
   }
    // Serial.println ("coil is off");
  //  Serial.print ("advancePulse ");
  //   Serial.println (advancePulse);
  //  Serial.print ("AdvSet ");
  //   Serial.println (AdvSet);
    
  }

  if ( sumwin == true && AdvSet == 1)// summer winter selected advance RTC as well when count gets to 240 (1 hour)
      {
     //    hh = hh+1;
     summertime = rtc.now().hour() + 1;
    // Serial.print ("sumertime ");
    // Serial.println (summertime);
      rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), summertime, rtc.now().minute(), rtc.now().second()));
         sumwin = false;
      }
  
 else if ( AdvSet == 0 )//AdvSet is set by VR1
{
 advanceLock = false;
} 
 
   
      if ( sumwin == true && AdvSet == 0)// summer winter selected advance RTC as well when count gets to 240 (1 hour)
      {
     //    hh = hh+1;
    // summertime = rtc.now().hour() + 1;
    // Serial.print ("sumertime ");
    // Serial.println (summertime);
   //   rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), summertime, rtc.now().minute(), rtc.now().second()));
         sumwin = false;
      }
     // AdvRtdSetUse = true;
    }
    
    else
    {
    // AdvSet = 0;
      retard = false;
      advance = false;
      AdvRtdSetUse = true;
      advancePulse = 0;
      sumwin = false;
    }


//Brett cancel advance/retard when opp button is press eg cancel adv- press rtd or cancel rtd press adv

 if (digitalRead(advanceSw) == LOW && retard == true && RtdSet > 1)
 {
  clockRun = true;
  RtdSet = 0;
 }
else if (digitalRead(retardSw) == LOW && advance == true && AdvSet > 1)
{
 
AdvSet = 0;

}


//Check every 10 seconds
 if ( get_sec() == 11 || get_sec() == 21 || get_sec() == 31 || get_sec() == 41 || get_sec() == 51 || get_sec() == 1 )
 {
  readLDR();
 }


 
 


 //####################################################

 
 //Brett
//Check every second

  secondNow = get_sec();
 // Serial.print("Second ");
//Serial.print(ss);
  if(secondNow!=secondPrevious || initial)
  {
    initial = 0;
 
    secondPrevious = secondNow;

  
   // 12/24hr clock mode
   //Print sensor value every second
 DigTimeSet = analogRead(DigTimeSetPin);    // read the value from the pot
if (DigTimeSet >= 930 && DigTimeSet < 1024 && Clock24Hour == 1)
 {
   Clock24Hour = 0; // 12 hr clock On 
   
 }
   
   
   //PIR

if (digitalRead(PIRPin) == LOW && PIROn == 1 && PIRtimer <(rtc.now().unixtime()) )//when PIRtimer is less than the time now & the PIR is low the LEDs go off
{
 //Serial.println("PIR Off ");
  lc.shutdown(0,true);
 // if(PIRtimer + 15 > (rtc.now().unixtime()))// add 15 second delay before enabling PIR again when turned off to stop false triggers
 // {
   PIROn = 0; // allows PIR to triger once
 // }
}

if (digitalRead(PIRPin) == HIGH && PIROn == 0 )
{
// Serial.print("Unix Time ");
 //  Serial.println((rtc.now().unixtime()));
 PIRtimer = (rtc.now().unixtime()+ PIRtimeout);// PIRtimer = Unix time now + PIRtimeout value in seconds.
 
//Serial.print("PIR Timer ");
 //  Serial.println(PIRtimer);
 
lc.shutdown(0,false);
 PIROn = 1; //allows PIR to triger once
}

  



   // converts seconds/minutes/hours to 2 single digits for 7 segment seconds display
   
    seconds2 = floor(get_sec()/10); //gets 2nd seconds char from seconds for 7 segment display
    seconds1 = get_sec() - (seconds2 * 10); //gets 1st seconds char from seconds for 7 segment display

    minutes2 = floor(get_min()/10); //gets 2nd seconds char from seconds for 7 segment display
    minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

    hours2 = floor(get_hour()/10); //gets 2nd seconds char from hours for 7 segment display
    hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display
/*
Serial.print("Time ");
Serial.print(hours2);
Serial.print(hours1);
Serial.print(":");
Serial.print(minutes2);
Serial.print(minutes1);
Serial.print(":");
Serial.print(seconds2);
Serial.println(seconds1);
*/

// Convert to 12 hour clock if Clock24Hour is set to 0;
if(Clock24Hour == 0 )
{
  
if(hours2 == 1 && hours1 >= 3)
{
hours2 = 0;
hours1 = hours1 - 2;
}

else if(hours2 == 2 && hours1 == 0)
{ 
hours2 = 0;
hours1 = 8;
}

else if(hours2 == 2 && hours1 == 1)
{ 
hours2 = 0;
hours1 = 9;
}

else if(hours2 == 2 && hours1 == 2)
{ 
hours2 = 1;
hours1 = 0;
}

else if(hours2 == 2 && hours1 == 3)
{ 
hours2 = 1;
hours1 = 1;
}

// Blank if 1st digit is 0
if (hours2 == 0)
{
  hours2 = " ";
}


}


//MAX72xx
 
   // If clock not retarding display time
  
  // if(retard == false)
  // {
    
    lc.setIntensity(0,max2719Intensity); // set 7 segment intensity to value of "intensity" from LDR
    lc.setChar(0,0,seconds1,false); // print 1st seconds digit on 7 segment display and "false" turns DP off
    lc.setChar(0,1,seconds2,false); // print 2nd seconds digit on 7 segment display and "false" turns DP off
    lc.setChar(0,2,'o',false); // print lower case O on 7 segment display and "false" turns DP off tape mask shows :
    lc.setChar(0,3,minutes1,false); // print 1st minutes digit on 7 segment display and "false" turns DP off
    lc.setChar(0,4,minutes2,false); // print 2nd minutes digit on 7 segment display and "false" turns DP off
    lc.setChar(0,5,'o',false); // print lower case O on 7 segment display and "false" turns DP off tape mask shows :
    lc.setChar(0,6,hours1,false); // print 1st minutes digit on 7 segment display and "false" turns DP off
    lc.setChar(0,7 ,hours2,false); // print 2nd minutes digit on 7 segment display and "false" turns DP off
 


   if(retard == true) //clock retarding show decimal points
   {
    
    lc.setIntensity(0,max2719Intensity); // set 7 segment intensity to value of "intensity" from LDR
   
   
   if( seconds1 == 0 || seconds1 == 2 || seconds1 == 4 || seconds1 == 6 || seconds1 == 8 )
   {
  
  // lc.setIntensity(0,max2719Intensity); // set 7 segment intensity to value of "intensity" from LDR
  lc.setIntensity(0,5); // set 7 segment intensity while retarding
   // lc.setChar(0,0,seconds2,true); // print 1st seconds digit on 7 segment display and "false" turns DP off
    //lc.setChar(0,0,seconds1,true); // print 1st seconds digit on 7 segment display and "false" turns DP off
   // lc.setChar(0,6,hours1,false); // print 1st minutes digit on 7 segment display and "false" turns DP off
   // lc.setChar(0,7 ,hours2,false); // print 2nd minutes digit on 7 segment display and "false" turns DP off
   }

  else if( seconds1 == 1 || seconds1 == 3 || seconds1 == 5 || seconds1 == 7 || seconds1 ==9 )
   {
  // lc.setIntensity(0,(max2719Intensity/3)); // set 7 segment intensity to value of "intensity" from LDR
  lc.setIntensity(0,0); // set 7 segment intensity while retarding
   //lc.shutdown(0,true); // tirn off 7 seg display on odd seconds to show retard in progress.
   // lc.setChar(0,0,seconds2,false); // print 1st seconds digit on 7 segment display and "false" turns DP off
   // lc.setChar(0,0,seconds1,false); // print 1st seconds digit on 7 segment display and "false" turns DP off
   // lc.setChar(0,6,hours1,true); // print 1st minutes digit on 7 segment display and "false" turns DP off
   // lc.setChar(0,7 ,hours2,true); // print 2nd minutes digit on 7 segment display and "false" turns DP off
    
   }
    
   }


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     //the following 3 lines ae used for setting up the LDR. Comment out after setup completed
   //  intensity = analogRead(intensityPin);    // read the value from the pot
    // Serial.print ("intensity Value ");
    // Serial.println (intensity);
   //  Serial.print ("max2719Intensity ");
   //  Serial.println (max2719Intensity);
    
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


//####################################################################################################################################################################
// Set digital time- set pot to digit and press relevant button to set that digit- hour1= hour tens, hour2= hour units,minute1= minute tens & minute2= minute units
    
 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     //the following 3 lines ae used for setting up the potentiometer. Comment out after setup completed
  //   DigTimeSet = analogRead(DigTimeSetPin);    // read the value from the pot
  //   Serial.print ("DigTimeSet Value ");
  //   Serial.println (DigTimeSet);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     
//set hours tens digit
if (digitalRead(hour1) == LOW )
 {
  DigitalClockSettings();// gets the int value DigitalClockDigit from VR2
  // we need to get the units of the hours for later
  unsigned n = rtc.now().hour();
  unsigned x = (n / 1U) % 10;// hours unit value
 // Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
  if( DigitalClockDigit < 3)//if greater than 2 not valind for hours tens digit
  {
 // Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
  DigitalClockDigit = (DigitalClockDigit * 10) + x ;// this is the value of DigitalClockDigit(hours tens) + hours unit value
 // Serial.print("hours ");
//Serial.println(n);

//Serial.print("hours unit ");
//Serial.println(x);

//Serial.print("New hours ");
//Serial.println( DigitalClockDigit);

  rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), DigitalClockDigit, rtc.now().minute(), rtc.now().second()));
  }
 }

//set hours units digit
if (digitalRead(hour2) == LOW )
 {
  DigitalClockSettings();// gets the int value DigitalClockDigit from VR2
  // we need to get the tens of the hours for later
  unsigned n = rtc.now().hour();
  unsigned x = (n / 10U) % 10;// hours tens value
 // Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
 
//  Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
  DigitalClockDigit = DigitalClockDigit + (10 * x) ;// this is the value of DigitalClockDigit(hours tens) + hours unit value
//  Serial.print("hours ");
//Serial.println(n);

//Serial.print("hours tens ");
//Serial.println(x);

//Serial.print("New hours ");
//Serial.println( DigitalClockDigit);

  rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), DigitalClockDigit, rtc.now().minute(), rtc.now().second()));
  
 }


 //set mins tens digit
if (digitalRead(minute1) == LOW )
 {
  DigitalClockSettings();// gets the int value DigitalClockDigit from VR2
  // we need to get the units of the minutes for later
  unsigned n = rtc.now().minute();
  unsigned x = (n / 1U) % 10;// mins unit value
//  Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
  if( DigitalClockDigit < 6)//if greater than 5 not valind for hours tens digit
  {
 // Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
  DigitalClockDigit = (DigitalClockDigit * 10) + x ;// this is the value of DigitalClockDigit(hours tens) + hours unit value
//  Serial.print("mins ");
//Serial.println(n);

//Serial.print("mins unit ");
//Serial.println(x);

//Serial.print("New minutes ");
//Serial.println( DigitalClockDigit);

  rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), rtc.now().hour(), DigitalClockDigit, rtc.now().second()));
  }
 }

//set mins units digit
if (digitalRead(minute2) == LOW )
 {
  DigitalClockSettings();// gets the int value DigitalClockDigit from VR2
  // we need to get the tens of the hours for later
  unsigned n = rtc.now().minute();
  unsigned x = (n / 10U) % 10;// hours tens value
//  Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
 
//  Serial.print("DigitalClockDigit ");
//Serial.println(DigitalClockDigit);
  DigitalClockDigit = DigitalClockDigit + (10 * x) ;// this is the value of DigitalClockDigit(hours tens) + hours unit value
 // Serial.print("minutes ");
//Serial.println(n);

//Serial.print("mins units ");
//Serial.println(x);

//Serial.print("New minutes ");
//Serial.println( DigitalClockDigit);

  rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), rtc.now().hour(), DigitalClockDigit, rtc.now().second()));
  
 }



// Brett amalagamated 1 sec loop
 // Brett do every second

 

 
secondsOld = secondsNow ;

     
  }
  //End check every second
 
  

 











} // end usual case (clock)



 
}  // end main loop

/*
void printText(char *text, uint16_t color, int x, int y,int textSize)
{
  tft.setCursor(x, y);
  tft.setTextColor(color);
  tft.setTextSize(textSize);
  tft.setTextWrap(true);
  tft.print(text);
}

*/
String getDayOfWeek(int i)
{
  switch(i)
  {
    case 0: return "Monday";break;
    case 1: return "Tuesday";break;
    case 2: return "Wednesday";break;
    case 3: return "Thursday";break;
    case 4: return "Friday";break;
    case 5: return "Saturday";break;
    case 6: return "Sunday";break;
    default: return "Monday";break;
  }
}




//================================================================================================================
//gets advance retard settings from pot
void AdvRtdSettings()
{

 //Print sensor value every second
 AdvRtdVal = analogRead(AdvRtdPin);    // read the value from the sensor
  // Serial.print ("Adv/Rtd Value ");
  // Serial.println (AdvRtdVal);
//------------------------------------------------


  // Set values for Adv/Rtd Sensor 
  //Summer/Winter
  if (AdvRtdVal >= 0 && AdvRtdVal < 113) 
  {
   AdvSet = 240; // Advance pulses
   RtdSet    = 3600; //retard pulses
  
   sumwin = true ;
   // Serial.print ("sunwin set ");
  // Serial.println (sumwin);
 }
 //15sec
 else if (AdvRtdVal >= 113 && AdvRtdVal < 226)
 {
   AdvSet = 1; // Advance  pulses
   RtdSet    = 15; //retard pulses
    sumwin = false ;
 }

 //5min
 else if (AdvRtdVal >= 226 && AdvRtdVal < 339)
 {
   AdvSet = 20; // Advance pulses
   RtdSet    = 300; //retard pulses
    sumwin = false ;
//  Serial.print ("sunwin set ");
//   Serial.println (sumwin);
 }

 //10min
 else if (AdvRtdVal >= 339 && AdvRtdVal < 452)
 {
   AdvSet = 40; // Advance pulses
   RtdSet    = 600; //retard pulses
    sumwin = false ;
  
 }

 //15min
 else if (AdvRtdVal >= 452 && AdvRtdVal < 565)
 {
   AdvSet = 60; // Advance pulses
   RtdSet    = 900; //retard pulses
    sumwin = false ;
 
 }

 //30min
 else if (AdvRtdVal >= 565 && AdvRtdVal < 678)
 {
   AdvSet = 120; // Advance pulses
   RtdSet    = 1800; //retard pulses
    sumwin = false ;
  
 }

 //45
 else if (AdvRtdVal >= 678 && AdvRtdVal < 791)
 {
   AdvSet = 180; // Advance pulses
   RtdSet    = 2700; //retard pulses
    sumwin = false ;
 
 }

 
 //1hr
 else if (AdvRtdVal >= 791 && AdvRtdVal < 904)
 {
   AdvSet = 240; // Advance pulses
   RtdSet    = 3600; //retard pulses
    sumwin = false ;
 
 }

 //6hr
 else if (AdvRtdVal >= 904 && AdvRtdVal < 1024)
 {
   AdvSet = 1440; // Advance pulses
   RtdSet    = 21600; //retard pulses
    sumwin = false ;
 
 }

}


//Digital Clock Setting
//================================================================================================================
//gets advance retard settings from pot
void DigitalClockSettings()
{

 //Print sensor value every second
 DigTimeSet = analogRead(DigTimeSetPin);    // read the value from the pot
   //Serial.print ("DigTimeSet Value ");
   //Serial.println (DigTimeSet);
//------------------------------------------------


  // Set values for DigTimeSet Pot 
  //0
  if (DigTimeSet >= 0 && DigTimeSet < 93) 
  {
   DigitalClockDigit = 0; // Digital Clock Digit
  Clock24Hour = 1; //24hr clock On
 }
 //1
 else if (DigTimeSet >= 93 && DigTimeSet < 186)
 {
   DigitalClockDigit = 1; // Advance  pulses
  Clock24Hour = 1; //24hr clock On
   
 }

 //2
 else if (DigTimeSet >= 186 && DigTimeSet < 279)
 {
   DigitalClockDigit = 2; // Digital Clock Digit
  Clock24Hour = 1; //24hr clock On
 }

 //3
 else if (DigTimeSet >= 279 && DigTimeSet < 372)
 {
   DigitalClockDigit = 3; // Digital Clock Digit
  Clock24Hour = 1; //24hr clock On
  
 }

 //4
 else if (DigTimeSet >= 372 && DigTimeSet < 465)
 {
   DigitalClockDigit = 4; // Digital Clock Digit
  Clock24Hour = 1; //24hr clock On
 
 }

 //5
 else if (DigTimeSet >= 465 && DigTimeSet < 558)
 {
   DigitalClockDigit = 5; // Digital Clock Digit
    Clock24Hour = 1; //24hr clock On 
 }

 //6
 else if (DigTimeSet >= 558 && DigTimeSet < 651)
 {
   DigitalClockDigit = 6; // Digital Clock Digit
  Clock24Hour = 1; //24hr clock On
 
 }

 
 //7
 else if (DigTimeSet >= 651 && DigTimeSet < 744)
 {
   DigitalClockDigit = 7; // Digital Clock Digit
   Clock24Hour = 1; //24hr clock On
 
 }

 //8
 else if (DigTimeSet >= 744 && DigTimeSet < 837)
 {
   DigitalClockDigit = 8; // Digital Clock Digit
   Clock24Hour = 1; //24hr clock On
 }

 //9
 else if (DigTimeSet >= 837 && DigTimeSet < 930)
 {
   DigitalClockDigit = 9; // Digital Clock Digit
   Clock24Hour = 1; //24hr clock On
 }

// 12/24hr clock mode
if (DigTimeSet >= 930 && DigTimeSet < 1024 && Clock24Hour == 1)
 {
   Clock24Hour = 0; // 12 hr clock On 
   
 }
 

}

//================================================================================================================


//================================================================================================================
// Get value from LDR for digital display intensity
void readLDR()
{
  //Check LDR value every min at 15 seconds 
 intensity = analogRead(intensityPin);    // read the value from the pot 

//0

if (intensity >= 0 && intensity < 64)
 {
   max2719Intensity = 0; // Advance  pulses
  
   
 }

//1
 else if (intensity >= 64 && intensity < 128)
 {
   max2719Intensity = 1; // Advance  pulses
  
   
 }

 //2
 else if (intensity >= 128 && intensity < 192)
 {
   max2719Intensity = 1; // Digital Clock Digit

 }

 //3
 else if (intensity >= 192 && intensity < 256)
 {
   max2719Intensity = 3; // Digital Clock Digit
  
  
 }

 //4
 else if (intensity >= 256 && intensity < 320 )
 {
   max2719Intensity = 4; // Digital Clock Digit
  
 
 }

 //5
 else if (intensity >= 320 && intensity < 384)
 {
   max2719Intensity = 5; // Digital Clock Digit
     
 }

 //6
 else if (intensity >= 384 && intensity < 448)
 {
   max2719Intensity = 6; // Digital Clock Digit
  
 
 }

 
 //7
 else if (intensity >= 448 && intensity < 512)
 {
   max2719Intensity = 7; // Digital Clock Digit
   
 
 }

 //8
 else if (intensity >= 512 && intensity < 576)
 {
   max2719Intensity = 8; // Digital Clock Digit
   
 }

 //9
 else if (intensity >= 576 && intensity < 640)
 {
   max2719Intensity = 9; // Digital Clock Digit
   
 }

 //10
 else if (intensity >= 640 && intensity < 704)
 {
   max2719Intensity = 10; // Digital Clock Digit
   
 }

 //11
 else if (intensity >= 704 && intensity < 768)
 {
   max2719Intensity = 11; // Digital Clock Digit
   
 }

 //12
 else if (intensity >= 768 && intensity < 832)
 {
   max2719Intensity = 12; // Digital Clock Digit
   
 }

 //13
 else if (intensity >= 832 && intensity < 896)
 {
   max2719Intensity = 13; // Digital Clock Digit
   
 }

 //14
 else if (intensity >= 896 && intensity < 960)
 {
   max2719Intensity = 14; // Digital Clock Digit
   
 }

 //15
 else if (intensity >= 960 && intensity < 1024)
 {
   max2719Intensity = 15; // Digital Clock Digit
   
 }

 
}

//================================================================================================================





//================================================================================================================
//Steps clock motor 4 times as the minute hand steps 1/4 of a minute per pulse
void clockCoilTimer()// called when seconds are 0 so minute hand needs to be stepped
{
 
 if ( motorPulse <= 3)// stop pulsing after 4 pulses
 {
  currentMillis = millis();  //get the current time
  if ((coilOn == 1) && (currentMillis - startMillis >= periodOn))  //test whether the period has elapsed
   { 
  coilOn = 0;
  digitalWrite(clockCoil01, coilStatus);
  digitalWrite(clockCoil02, !coilStatus);
  
  startMillis = currentMillis;
 // Serial.println ("coil is energised");  
   }
 else if ((coilOn == 0) && (currentMillis - startMillis >= periodOff))  //test whether the period has elapsed
  {
   coilOn = 1;
   coilStatus = !coilStatus;
    digitalWrite(clockCoil01, 0);
  digitalWrite(clockCoil02, 0);
    startMillis = currentMillis;  //IMPORTANT to save the start time of the current
   ++ motorPulse;
    // Serial.println ("coil is off");
   //  Serial.print ("motorPulse ");
   //  Serial.println (motorPulse);
  } 
 }
}


/*
// Clock advance
//Steps clock motor 4 times as the minute hand steps 1/4 of a minute per pulse
void clockAdvance()// called when seconds are 0 so minute hand needs to be stepped
{
 
 if ( AdvRtdSet > 0 )//AdvRtdSet is set by VR1
 {
 // advanceLock = true;
  currentMillis = millis();  //get the current time
  if ((coilOn == 1) && (currentMillis - startMillis >= periodOn))  //test whether the period has elapsed
   { 
  coilOn = 0;
  digitalWrite(clockCoil01, coilStatus);
  digitalWrite(clockCoil02, !coilStatus);
  
  startMillis = currentMillis;
 // Serial.println ("coil is energised");  
   }
 else if ((coilOn == 0) && (currentMillis - startMillis >= periodOff))  //test whether the period has elapsed
  {
   coilOn = 1;
   coilStatus = !coilStatus;
    digitalWrite(clockCoil01, 0);
  digitalWrite(clockCoil02, 0);
    startMillis = currentMillis;  //IMPORTANT to save the start time of the current
   AdvRtdSet--;
 
   
    // Serial.println ("coil is off");
    Serial.print ("advancePulse ");
     Serial.println (advancePulse);
    Serial.print ("AdvRtdSet ");
     Serial.println (AdvRtdSet);
  }
 else if ( AdvRtdSet == 0 )//AdvRtdSet is set by VR1
{
 advanceLock = false;
} 
 }

}

*/

//Returns integer value of the second.
int get_sec(void){
  int s;
  s = (int)rtc.now().second();
  return s;
}

//Returns integer value of the minute.
int get_min(void){
  int m;
  m = (int)rtc.now().minute();
  return m;
}

//Returns integer value of the hour.
int get_hour(void){
  int h;
  h = (int)rtc.now().hour();
  return h;
}

//Returns integer value of the day.
int get_day(void){
  int dd;
  dd = (int)rtc.now().day();
  return dd;
}

//Returns integer value of the month.
int get_month(void){
  int mth;
  mth = (int)rtc.now().month();
  return mth;
}

//Returns integer value of the year.
int get_year(void){
  int yy;
  yy = (int)rtc.now().year();
  return yy;
}






/*
// read temperature and humidity every 15mins
void temphumidread()
{
if ( (ss == 15 && (mm == 15 || mm == 30 || mm == 45 || mm == 1) && advance == 0 ) || initialtemp || initial )// read temp & humidity every 1min @ 15seconds past but not when advancing
{
temperature = dht.readTemperature();
umiditate = dht.readHumidity();


// Brett check min max temp

 if ((temperature != previousTemperature) || initial)
  {
    previousTemperature = temperature;
    String temperatureString = String(temperature,1);
    temperatureString.toCharArray(temperatureChar,10);
    tft.fillRect(25,53,35,7,ST7735_BLACK); // Across, Down, Width, Hieght
    printText(temperatureChar, ST7735_GREEN,25,53,1); // Across Down Font size 
    printText("o", ST7735_GREEN,49,51,1);
    printText("C", ST7735_GREEN,55,53,1);

  if((umiditate != previousHumidity) || initial)
  {
    previousHumidity = umiditate;
    String umiditateString = String(umiditate);
    umiditateString.toCharArray(umiditateChar,10);
    tft.fillRect(70,53,40,7,ST7735_BLACK); //Brett test  Across, Down, Width, Hieght
    printText(umiditateChar, ST7735_GREEN,90,53,1);
    printText("%", ST7735_GREEN,103,53,1);
  }
  }

 if (hh == 0 && mm == 0 && ss == 0)// resets min max temps at midnight
 {
  previousmaxTemperature = 1;
  previousminTemperature = 200;
 }

 
//Brett Temp Min Max
   maxTemperature = temperature ;
 if ((maxTemperature > previousmaxTemperature) || initialtemp)
  {
    previousmaxTemperature = maxTemperature;
    String maxTemperatureString = String(maxTemperature,1);
    maxTemperatureString.toCharArray(charMaxTemperature,10);
    tft.fillRect(25,67,35,7,ST7735_BLACK); // Across, Down, Width, Hieght
    printText(charMaxTemperature, ST7735_RED,25,67,1); // Across Down Font size 
    printText("o", ST7735_RED,49,65,1);
    printText("C", ST7735_RED,55,67,1);
  }
    minTemperature = temperature ;

     
  
  if ((minTemperature < previousminTemperature) || initialtemp )
  {
    previousminTemperature = minTemperature;
     String minTemperatureString = String(minTemperature,1);
    minTemperatureString.toCharArray(charMinTemperature,10);
    tft.fillRect(90,67,25,7,ST7735_BLACK); //Brett test  Across, Down, Width, Hieght
    printText(charMinTemperature, ST7735_BLUE,90,67,1);
    printText("o", ST7735_BLUE,114,65,1);
    printText("C", ST7735_BLUE,120,67,1);
    
  }
 
 initialtemp = 0 ;
}
}
*/
//================================================================================================================
//
